﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XamDiagramExportToImageCase
{
    public class EmployeeViewModel : INotifyPropertyChanged
    {
        public EmployeeViewModel()
        {

            var employees = new ObservableCollection<Employee>();

            var sharedEmployee = new Employee("Shared Employee");
            employees.Add(new Manager("Manager 1")
            {
                Subordinates = new List<Employee>()
            {
                new Employee("Employee 1"),
                new Employee("Employee 2"),
                new Employee("Employee 3"),
                new Employee("Employee 4"),
                sharedEmployee
            }
            });
            employees.Add(new Manager("Manager 2")
            {
                Subordinates = new List<Employee>()
            {
                sharedEmployee,
                new Employee("Employee 5"),
                new Employee("Employee 6"),
                new Employee("Employee 7"),
                new Employee("Employee 8"),
                new Employee("Employee 9")
            }
            });
            employees.Add(new Employee("Employee 10"));

            Employees = employees;
        }
        private IList<Employee> _employees;

        public IList<Employee> Employees
        {
            get { return _employees; }
            set
            {
                _employees = value;
                OnPropertyChanged();
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged([CallerMemberName] string propertyName = "")
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
