﻿using Infragistics.Controls.Charts;
//using Infragistics.Persistence;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using HierarchicalDataTemplate = Infragistics.Controls.HierarchicalDataTemplate;

namespace XamDiagramExportToImageCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += MainWindow_Loaded;
            this.DataContext = new EmployeeViewModel();
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {

            ArrangeLayout();
        }

        private void ArrangeLayout()
        {

            HierarchicalDiagram.Layout = new ForceDirectedGraphDiagramLayout(); //TreeDiagramLayout();
            HierarchicalDiagram.UpdateLayout();

        }



        private void SaveLoadBtn_Click(object sender, RoutedEventArgs e)
        {

            string result;

            HierarchicalDiagram.ClearUndoRedoHistory();
            HierarchicalDiagram.UndoManager = null;
            HierarchicalDiagram.Layout = null;


            var stream = Infragistics.Persistence.PersistenceManager.Save(HierarchicalDiagram);


            HierarchicalDiagram.Items.Clear();

            try
            {
                Infragistics.Persistence.PersistenceManager.Load(HierarchicalDiagram, stream);
            }
            catch (System.Reflection.AmbiguousMatchException amx)
            {
                System.Diagnostics.Debug.WriteLine(amx.ToString());
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.ToString());
                //throws PersistenceGroup elements don't match elements in stream Exception thrown: 'Infragistics.Persistence.InvalidPersistenceGroupException' in InfragisticsWPF4.Persistence.v16.1.dll
            }


            //    this.DataContext = new EmployeeViewModel();

            //ArrangeLayout();

        }

    
    }
}
