﻿// Decompiled with JetBrains decompiler
// Type: Infragistics.Controls.Charts.ForceDirectedGraphDiagramLayout
// Assembly: InfragisticsWPF4.Controls.Charts.XamDiagram.v16.1, Version=16.1.20161.1000, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb
// MVID: 88BBF904-CB8F-433B-B232-4B61A6C5E97B
// Assembly location: C:\dev\Resolve10_2012\Dev\Backlog_Sprint_160530\3rd Party\IGX.16.1\WPF\InfragisticsWPF4.Controls.Charts.XamDiagram.v16.1.dll

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;

namespace Infragistics.Controls.Charts
{
    /// <summary>
    /// Force-directed graph layout using the Fruchterman–Reingold algorithm.
    /// 
    /// </summary>
    public class ForceDirectedGraphDiagramLayout : FrameworkElement, IDiagramLayout
    {
        /// <summary>
        /// Identifies the AverageNodeSize dependency property.
        /// 
        /// </summary>
        public static readonly DependencyProperty AverageNodeSizeProperty = DependencyProperty.Register("AverageNodeSize", typeof(Size), typeof(ForceDirectedGraphDiagramLayout), new PropertyMetadata((object)Size.Empty));
        /// <summary>
        /// Identifies the Buffer dependency property.
        /// 
        /// </summary>
        public static readonly DependencyProperty BufferProperty = DependencyProperty.Register("Buffer", typeof(double), typeof(ForceDirectedGraphDiagramLayout));
        private const string AverageNodeSizePropertyName = "AverageNodeSize";
        private const string BufferPropertyName = "Buffer";
        private List<Tuple<List<DiagramNode>, int>> _connectedComponents;
        private FruchtermanReingoldInternal _fd;

        /// <summary>
        /// Gets or sets the average node size. If this property is not set,
        ///             the average size will be calculated separately for each of the graph's connected components.
        /// 
        /// </summary>
        public Size AverageNodeSize
        {
            get
            {
                return (Size)this.GetValue(ForceDirectedGraphDiagramLayout.AverageNodeSizeProperty);
            }
            set
            {
                this.SetValue(ForceDirectedGraphDiagramLayout.AverageNodeSizeProperty, (object)value);
            }
        }

        /// <summary>
        /// Gets or sets the optimal buffer between nodes.
        /// 
        /// </summary>
        public double Buffer
        {
            get
            {
                return (double)this.GetValue(ForceDirectedGraphDiagramLayout.BufferProperty);
            }
            set
            {
                this.SetValue(ForceDirectedGraphDiagramLayout.BufferProperty, (object)value);
            }
        }

        /// <summary>
        /// Arranges the nodes.
        /// 
        /// </summary>
        /// <param name="nodes">All the nodes in the <see cref="P:Infragistics.Controls.Charts.XamDiagram.Items"/> collection.</param>
        public void ArrangeNodes(IEnumerable<DiagramNode> nodes)
        {
            this._connectedComponents = ForceDirectedGraphDiagramLayout.GetConnectedComponents(nodes);
            Rect rect = Rect.Empty;
            bool flag = false;
            double num1 = 0.0;
            double num2 = 0.0;
            double val1_1 = 0.0;
            double val1_2 = 0.0;
            foreach (Tuple<List<DiagramNode>, int> tuple in this._connectedComponents)
            {
                Size size = !this.AverageNodeSize.IsEmpty ? this.AverageNodeSize : ForceDirectedGraphDiagramLayout.GetNodesAverageSize(tuple.Item1);
                IList<Point> positions;
                if (tuple.Item1.Count > 1)
                    positions = this.ComputeLocations(tuple.Item1, size.Width, size.Height, false, this.Buffer, tuple.Item2);
                else
                    positions = (IList<Point>)new Point[1]
                    {
            tuple.Item1[0].Position
                    };
                Rect accumulatedBounds = ForceDirectedGraphDiagramLayout.GetAccumulatedBounds(positions, (IList<DiagramNode>)tuple.Item1);
                if (rect.IsEmpty)
                {
                    ForceDirectedGraphDiagramLayout.SetNodeFinalPosition(positions, (IList<DiagramNode>)tuple.Item1, -accumulatedBounds.Left + 15.0, -accumulatedBounds.Top + 15.0);
                    rect = new Rect(0.0, 0.0, accumulatedBounds.Width + 15.0, accumulatedBounds.Height + 15.0);
                    if (rect.Width > rect.Height)
                    {
                        num1 = rect.Left + 15.0;
                        num2 = rect.Bottom + 10.0;
                        flag = true;
                    }
                    else
                    {
                        num1 = rect.Right + 10.0;
                        num2 = rect.Top + 15.0;
                        flag = false;
                    }
                }
                else
                {
                    if (flag)
                    {
                        if (num1 + accumulatedBounds.Width > rect.Right)
                        {
                            num1 = rect.Left + 15.0;
                            num2 += val1_2 + 10.0;
                            val1_2 = 0.0;
                        }
                    }
                    else if (num2 + accumulatedBounds.Height > rect.Bottom)
                    {
                        num1 += val1_1 + 10.0;
                        num2 = rect.Top + 15.0;
                        val1_1 = 0.0;
                    }
                    ForceDirectedGraphDiagramLayout.SetNodeFinalPosition(positions, (IList<DiagramNode>)tuple.Item1, num1 - accumulatedBounds.Left, num2 - accumulatedBounds.Top);
                    accumulatedBounds.X = num1;
                    accumulatedBounds.Y = num2;
                    rect.Union(accumulatedBounds);
                    if (flag)
                        num1 += accumulatedBounds.Width + 10.0;
                    else
                        num2 += accumulatedBounds.Height + 10.0;
                    val1_1 = Math.Max(val1_1, accumulatedBounds.Width);
                    val1_2 = Math.Max(val1_2, accumulatedBounds.Height);
                }
            }
            if (!(rect != Rect.Empty))
                return;
            rect.Width += 15.0;
            rect.Height += 15.0;
        }

        private static void SetNodeFinalPosition(IList<Point> positions, IList<DiagramNode> nodes, double x, double y)
        {
            for (int index = 0; index < positions.Count; ++index)
            {
                Point point = new Point(positions[index].X + x, positions[index].Y + y);
                nodes[index].Position = point;
            }
        }

        private IList<Point> ComputeLocations(List<DiagramNode> nodes, double width, double height, bool isLayoutRandom, double k, int nodesNumber)
        {
            if (this._fd == null)
                this._fd = new FruchtermanReingoldInternal()
                {
                    Beautify = true
                };
            this._fd.IsLayoutRandom = isLayoutRandom;
            if (k <= 0.0 || double.IsNaN(k) || double.IsInfinity(k))
                k = Math.Sqrt(width * height);
            this._fd.K = (float)k;
            this._fd.Width = (float)(Math.Pow((double)nodes.Count, 0.83) * (width + (double)this._fd.K));
            this._fd.Height = (float)(Math.Pow((double)nodes.Count, 0.83) * (height + (double)this._fd.K));
            return (IList<Point>)this._fd.ComputeLocations((IEnumerable<DiagramNode>)nodes, nodesNumber, true);
        }

        private static List<Tuple<List<DiagramNode>, int>> GetConnectedComponents(IEnumerable<DiagramNode> nodes)
        {
            HashSet<DiagramNode> hashSet1 = new HashSet<DiagramNode>();
            HashSet<DiagramNode> hashSet2 = new HashSet<DiagramNode>();
            List<Tuple<List<DiagramNode>, int>> list1 = new List<Tuple<List<DiagramNode>, int>>(1);
            Queue<DiagramNode> queue = new Queue<DiagramNode>();
            foreach (DiagramNode diagramNode1 in nodes)
            {
                if (!hashSet1.Contains(diagramNode1))
                {
                    List<DiagramNode> list2 = new List<DiagramNode>();
                    int num = 0;
                    queue.Clear();
                    hashSet1.Add(diagramNode1);
                    queue.Enqueue(diagramNode1);
                    list2.Add(diagramNode1);
                    while (queue.Count > 0)
                    {
                        DiagramNode diagramNode2 = queue.Dequeue();
                        ++num;
                        foreach (DiagramConnection diagramConnection in (ReadOnlyCollection<DiagramConnection>)diagramNode2.OutgoingConnections)
                        {
                            DiagramNode endNode = diagramConnection.EndNode;
                            if (endNode != null && !hashSet1.Contains(endNode))
                            {
                                hashSet1.Add(endNode);
                                queue.Enqueue(endNode);
                                list2.Add(endNode);
                            }
                        }
                        foreach (DiagramConnection diagramConnection in (ReadOnlyCollection<DiagramConnection>)diagramNode2.IncomingConnections)
                        {
                            DiagramNode startNode = diagramConnection.StartNode;
                            if (startNode != null && !hashSet1.Contains(startNode))
                            {
                                hashSet1.Add(startNode);
                                queue.Enqueue(startNode);
                                list2.Add(startNode);
                            }
                        }
                    }
                    list1.Add(new Tuple<List<DiagramNode>, int>(list2, num));
                }
            }
            return list1;
        }

        private static Size GetNodesAverageSize(List<DiagramNode> nodes)
        {
            double num1 = 0.0;
            double num2 = 0.0;
            foreach (DiagramNode diagramNode in nodes)
            {
                num1 += diagramNode.Bounds.Width;
                num2 += diagramNode.Bounds.Height;
            }
            return new Size(num1 / (double)nodes.Count, num2 / (double)nodes.Count);
        }

        private static Rect GetAccumulatedBounds(IList<Point> positions, IList<DiagramNode> nodes)
        {
            Rect rect = new Rect(positions[0], nodes[0].Bounds.Size);
            for (int index = 1; index < nodes.Count; ++index)
                rect.Union(new Rect(positions[index], nodes[index].Bounds.Size));
            return rect;
        }
    }
}
