﻿// Decompiled with JetBrains decompiler
// Type: Infragistics.Controls.Charts.FruchtermanReingoldInternal
// Assembly: InfragisticsWPF4.Controls.Charts.XamDiagram.v16.1, Version=16.1.20161.1000, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb
// MVID: 88BBF904-CB8F-433B-B232-4B61A6C5E97B
// Assembly location: C:\dev\Resolve10_2012\Dev\Backlog_Sprint_160530\3rd Party\IGX.16.1\WPF\InfragisticsWPF4.Controls.Charts.XamDiagram.v16.1.dll

using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;

namespace Infragistics.Controls.Charts
{
    internal class FruchtermanReingoldInternal
    {
        private List<DiagramNode> _nodes;
        private Point[] _positions;
        private DiagramConnection[] _connections;
        private float[] _xPos;
        private float[] _yPos;
        private float[] _dispX;
        private float[] _dispY;
        private Rect[] _bounds;
        private Dictionary<DiagramNode, int> _nodeToIndexMap;

        public bool Beautify { get; set; }

        public float W { get; set; }

        public float K { get; set; }

        public float Height { get; set; }

        public float Width { get; set; }

        public int Iterations { get; set; }

        public bool IsLayoutRandom { get; set; }

        internal float KSquared { get; set; }

        public FruchtermanReingoldInternal()
        {
            this.Iterations = 100;
            this.K = 40f;
            this.W = 20f;
            this.Height = 800f;
            this.Width = 1200f;
        }

        public Point[] ComputeLocations(IEnumerable<DiagramNode> nodes, int nodesNumber, bool initializeInitialLocations)
        {
            float t1 = Math.Min(this.Width, this.Height) * 0.1f;
            float num = t1 * 0.01f;
            this._nodes = Enumerable.ToList<DiagramNode>(nodes);
            this._connections = Enumerable.ToArray<DiagramConnection>(Enumerable.SelectMany<DiagramNode, DiagramConnection>((IEnumerable<DiagramNode>)this._nodes, (Func<DiagramNode, IEnumerable<DiagramConnection>>)(node => Enumerable.Where<DiagramConnection>((IEnumerable<DiagramConnection>)node.OutgoingConnections, (Func<DiagramConnection, bool>)(c => c.EndNode != null)))));
            this._xPos = new float[this._nodes.Count];
            this._yPos = new float[this._nodes.Count];
            this._dispX = new float[this._nodes.Count];
            this._dispY = new float[this._nodes.Count];
            this._positions = new Point[this._nodes.Count];
            this.InitializeNodeLocations(nodesNumber);
            if (this.Beautify)
                this._bounds = new Rect[this._nodes.Count];
            this._nodeToIndexMap = new Dictionary<DiagramNode, int>(this._nodes.Count);
            for (int index = 0; index < this._nodes.Count; ++index)
            {
                this._nodeToIndexMap[this._nodes[index]] = index;
                if (this.Beautify)
                    this._bounds[index] = new Rect((double)this._xPos[index], (double)this._yPos[index], this._nodes[index].Bounds.Width, this._nodes[index].Bounds.Height);
            }
            this.KSquared = this.K * this.K;
            for (int index = 0; index < this.Iterations && (double)t1 > (double)num; ++index)
            {
                this.RepulsiveForces();
                this.AttractionForces();
                this.LimitDisplacement(t1, true);
                t1 *= 0.95f;
            }
            if (this.Beautify && this._nodes.Count < 251)
            {
                float t2 = (float)((double)Math.Min(this.Width, this.Height) * 0.100000001490116 / 10.0);
                for (int index = 0; index < this.Iterations && (double)t2 > (double)num; ++index)
                {
                    this.RepulsiveForcesBeautify();
                    this.AttractionForcesBeautify();
                    this.LimitDisplacement(t2, true);
                    t2 *= 0.95f;
                }
            }
            return this._positions;
        }

        private void RepulsiveForces()
        {
            for (int index1 = 0; index1 < this._nodes.Count - 1; ++index1)
            {
                for (int index2 = index1 + 1; index2 < this._nodes.Count; ++index2)
                {
                    float num1 = this._xPos[index1] - this._xPos[index2];
                    float num2 = this._yPos[index1] - this._yPos[index2];
                    float num3 = (float)((double)num1 * (double)num1 + (double)num2 * (double)num2);
                    float num4;
                    float num5;
                    if ((double)num3 <= 0.0001)
                    {
                        num4 = this.KSquared * 1000f;
                        num5 = this.KSquared * 1000f;
                    }
                    else
                    {
                        float num6 = this.KSquared / num3;
                        num4 = num1 * num6;
                        num5 = num2 * num6;
                    }
                    this._dispX[index1] += num4;
                    this._dispY[index1] += num5;
                    this._dispX[index2] -= num4;
                    this._dispY[index2] -= num5;
                }
            }
        }

        private void RepulsiveForcesBeautify()
        {
            for (int i = 0; i < this._nodes.Count - 1; ++i)
            {
                for (int j = i + 1; j < this._nodes.Count; ++j)
                {
                    float num1 = this._xPos[i] - this._xPos[j];
                    float num2 = this._yPos[i] - this._yPos[j];
                    float num3;
                    float num4;
                    if (this._bounds[i].IntersectsWith(this._bounds[j]))
                    {
                        num3 = num1 * (this.KSquared * 1000f);
                        num4 = num2 * (this.KSquared * 1000f);
                    }
                    else
                    {
                        float num5 = this.KSquared / (this.GetDistanceSquared(i, j) / this.W);
                        num3 = num1 * num5;
                        num4 = num2 * num5;
                    }
                    this._dispX[i] += num3;
                    this._dispY[i] += num4;
                    this._dispX[j] -= num3;
                    this._dispY[j] -= num4;
                }
            }
        }

        private void AttractionForces()
        {
            foreach (DiagramConnection diagramConnection in this._connections)
            {
                int index1 = this._nodeToIndexMap[diagramConnection.StartNode];
                int index2 = this._nodeToIndexMap[diagramConnection.EndNode];
                float num1 = this._xPos[index1] - this._xPos[index2];
                float num2 = this._yPos[index1] - this._yPos[index2];
                float num3 = (float)Math.Sqrt((double)num1 * (double)num1 + (double)num2 * (double)num2);
                float num4;
                float num5;
                if ((double)num3 <= 0.01)
                {
                    num4 = 0.0f;
                    num5 = 0.0f;
                }
                else
                {
                    float num6 = num3 / this.K;
                    num4 = num1 * num6;
                    num5 = num2 * num6;
                }
                this._dispX[index1] -= num4;
                this._dispY[index1] -= num5;
                this._dispX[index2] += num4;
                this._dispY[index2] += num5;
            }
        }

        private void AttractionForcesBeautify()
        {
            foreach (DiagramConnection diagramConnection in this._connections)
            {
                int i = this._nodeToIndexMap[diagramConnection.StartNode];
                int j = this._nodeToIndexMap[diagramConnection.EndNode];
                float num1 = this._xPos[i] - this._xPos[j];
                float num2 = this._yPos[i] - this._yPos[j];
                float num3;
                float num4;
                if (this._bounds[i].IntersectsWith(this._bounds[j]))
                {
                    num3 = 0.0f;
                    num4 = 0.0f;
                }
                else
                {
                    float num5 = this.GetDistanceSquared(i, j) / this.K;
                    num3 = num1 * num5;
                    num4 = num2 * num5;
                }
                this._dispX[i] -= num3;
                this._dispY[i] -= num4;
                this._dispX[j] += num3;
                this._dispY[j] += num4;
            }
        }

        private void LimitDisplacement(float t, bool setLocation)
        {
            for (int index = 0; index < this._nodes.Count; ++index)
            {
                DiagramNode diagramNode = this._nodes[index];
                float val1 = Math.Max((float)Math.Sqrt((double)this._dispX[index] * (double)this._dispX[index] + (double)this._dispY[index] * (double)this._dispY[index]), float.Epsilon);
                this._dispX[index] = this._xPos[index] + this._dispX[index] / val1 * Math.Min(val1, t);
                this._dispY[index] = this._yPos[index] + this._dispY[index] / val1 * Math.Min(val1, t);
                this._dispX[index] = Math.Min(this.Width, Math.Max(0.0f, this._dispX[index]));
                this._dispY[index] = Math.Min(this.Height, Math.Max(0.0f, this._dispY[index]));
                this._xPos[index] = this._dispX[index];
                this._yPos[index] = this._dispY[index];
                if (setLocation)
                {
                    this._positions[index] = new Point((double)this._dispX[index], (double)this._dispY[index]);
                    if (this.Beautify)
                    {
                        this._bounds[index].X = (double)this._dispX[index];
                        this._bounds[index].Y = (double)this._dispY[index];
                    }
                }
                this._dispX[index] = 0.0f;
                this._dispY[index] = 0.0f;
            }
        }

        private float GetDistanceSquared(int i, int j)
        {
            double num1 = 0.0;
            double num2 = Math.Max(this._bounds[i].Left, this._bounds[j].Left) - Math.Min(this._bounds[i].Right, this._bounds[j].Right);
            if (num2 > 0.0)
                num1 += num2 * num2;
            double num3 = Math.Max(this._bounds[i].Top, this._bounds[j].Top) - Math.Min(this._bounds[i].Bottom, this._bounds[j].Bottom);
            if (num3 > 0.0)
                num1 += num3 * num3;
            return (float)num1;
        }

        protected void InitializeNodeLocations(int nodesNumber)
        {
            Random randomGenerator = this.GetRandomGenerator(nodesNumber);
            for (int index = 0; index < nodesNumber; ++index)
            {
                this._xPos[index] = (float)Math.Max(double.Epsilon, randomGenerator.NextDouble() * (double)this.Width);
                this._yPos[index] = (float)Math.Max(double.Epsilon, randomGenerator.NextDouble() * (double)this.Height);
            }
        }

        protected Random GetRandomGenerator(int seed)
        {
            if (this.IsLayoutRandom)
                return new Random();
            return new Random(seed);
        }
    }
}
